# 2048

Join the numbers and get to the 2048 tile.

* Based on 2048 created by Gabriele Cirulli.
* Based on the console version for GNU/Linux by Maurits van der Schee
* Ported to Z80 and CP/M by Marco Maccaferri <macca@maccasoft.com>

Original Repository: https://github.com/maccasoft/z80-apps

In this version some minimal changes were applied:
* On startup, clearing the screen will be performed by the standard
  VT100 ``^[2J``.
* The "arrow symbols" below the playfield are symbolized by <>^v, as
  the symbols used before actually are control characters that most
  VT100 terminals do not display.
* The newer version without the undocumented opcode is used.

## Commands

Use the arrow keys to move the tiles.

When two tiles with the same number touch, they merge into one.

* w, s, a, d - Alternate keys (up, down, left, right)
* CTRL-E, CTRL-X, CTRL-S, CTRL-D - Wordstar-compatible control keys

## Compile:

If using TASM, the command is: ``TASM -80 -b 2048.ASM 2048.COM``

The "Micro Z80 Assembler" was used to assemble ``2048.COM`` on Linux.
It is provided in the directory ``uz80as``, just compile it using ``make``.

The command for assembling 2048 is: ``uz80as 2048.ASM 2048.COM``.

uz80as can be found here: https://github.com/jorgicor/uz80as
The uz80as directory here is taken from the RomWBW source tree.

## License:

From original repository:

Unless otherwise specified all programs are distributed with the GNU GPL-V3 license, images, design files and other artwork are distributed under the Creative Commons Attribution-ShareAlike 3.0 license.

