# Packages

In this directory, I created ``.zip`` packages of all games for BBS distribution.

The files are created by using Info-ZIP ``zip`` on Linux.

## The .zip packages

All .zip packages are placed in the directory [ZIP](ZIP/).

The files can be extracted using the CP/M UNZIP command that can also be found here:

* [UNZIP154.COM](UNZIP154.COM) - CP/M binary
* [UNZIP154.LBR](UNZIP154.LBR) - archive including source

The Github repository for this UNZIP can be found here: https://github.com/agn453/UNZIP-CPM-Z80

## Package creation

I've created scripts to automatically create the .zip archives as well as the HDimage.
For this to work, in every game directory, a file called ``.package`` is created which controls
the package creation process.

``.package`` is a semicolon separated file.

The first value contains a letter which indicates:

| N | name of the package (for .zip creation)         |
| F | file (binary or game data)                      |
| S | source file (won't be put into HDimage)         |
| R | README file, will be renamed <packagename>.DOC  |
| D | description, will be put into ``FILE_ID.DIZ``   |

The second value contains the value for the kind of line.

Optionally, a third value can exist for ``F``, ``S`` and ``R`` lines which defines a target filename,
eg. if the original filename does not conform to the ``8.3`` format. The file will be put in the archive
under this new filename.
For example:

    S;gpl-3.0.txt;GPL3.TXT

will put the file ``gpl-3.0.txt`` as ``GPL3.TXT`` in the .zip file, but not in the HDimage (as
source files will only be put in the .zip archives).


